//***************************************************************************
//
//   class mds_exception (from MDS v.5.2)
//   for generating exceptions in _DEBUG mode 
//   (c) 2002-2004 Dr.Bashnyakov A. 
//   (bash@unicyb.kiev.ua)
//
//***************************************************************************
//                                                                         
//   This program is free software; you can redistribute it and/or modify  
//   it under the terms of the GNU General Public License as published by  
//   the Free Software Foundation; either version 2 of the License, or     
//   (at your option) any later version.                                   
//                                                                         
//***************************************************************************


#ifndef _mds_exception_h_
#define _mds_exception_h_


#include <iostream>
#include <exception>
#include <string>

struct mds_exception : public std::exception
{
        const char* _about;

        mds_exception() throw ()
        {
        }

        mds_exception(const char* msg) throw ()
                : _about(msg)
        {
        }

        virtual const char* what() const throw()
        { 
                return _about;
        }

        virtual ~mds_exception() throw()
        {
        }
};

// exceptions: whith console output
struct mds_exception_message : public mds_exception
{
        mds_exception_message()
        {
        }

        mds_exception_message(const char* msg)
	        : mds_exception(msg)
        {
	        std::cerr << "MDS exception: " << what() << std::endl;
        }
};


#endif  
